using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Drawing.Imaging;

namespace Anket
{
	/// <summary>
	/// Summary description for anketsonuc.
	/// </summary>
	public class anketsonuc : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Image imgAnket;

		// Anket sonularn depolamak iin 5 elemanl bir dizi oluturuluyor...
		private int[] Sonuc = new int[5];

		// Anket sonularnn yzdelik oranlarn depolamak iin 5 elemanl bir dizi oluturuyoruz...
		private int[] SonucYuzde = new int[5];
		
		// Anket cevaplarnn ksaltmalarn bir diziye ekliyoruz...
		private string[] Cevaplar = new string[5] {"FB","BJK","GS","TS","D"};

		// izilecek dikey ubuklarn genilii...
		private int Bar_W = 30;

		private void Page_Load(object sender, System.EventArgs e)
		{				
			// Anket sonular reniliyor...
			string strFile = Server.MapPath("Anket.xml"); 
			
			XmlDocument xmlAnket = new XmlDocument();
			xmlAnket.Load(strFile);

			int nToplamOy = 0;

			for(int i=0; i<5; ++i)
			{
				Sonuc[i] = Convert.ToInt32(xmlAnket.SelectSingleNode("/Hits/Hit["+ Convert.ToString(i+1) +"]").InnerText);
				nToplamOy += Sonuc[i];
			}

			// Sonularn yzdelik deerlerini hesaplayp SonucYuzde[] dizisine aktaryoruz...
			// Bu deerleri grafik iziminde kullanacaz.
			for(int i=0; i<5; ++i)
				SonucYuzde[i] = Sonuc[i] * 100 / nToplamOy;

			// Sonulara gre grafik oluturuluyor...
			GrafikOlustur();
		}

		private void GrafikOlustur()
		{
			// imgGrafik nesnemizin boyutlar alnyor...
			int imgAnket_W = Convert.ToInt32(imgAnket.Width.Value);
			int imgAnket_H = Convert.ToInt32(imgAnket.Height.Value);

			// Bitmap nesnesi oluturuluyor...
			Bitmap bmpAnket = new Bitmap(imgAnket_W, imgAnket_H);
			
			// Graphics nesnesi oluturuluyor... 
			Graphics grpAnket = Graphics.FromImage(bmpAnket);

			// 2 farkl boyutta Font nesnesi oluturuluyor...
			Font fntKucukFont = new Font("Tahoma", 8);
			Font fntBuyukFont = new Font("Tahoma", 12);

			// Tuvalimizin arka plan sar renkle boyanyor... 
			grpAnket.FillRectangle(new SolidBrush(Color.Yellow), 0, 0, imgAnket_W, imgAnket_H);

			// Tuvalimize (grpGrafik) 2 tane metin yazdryoruz...
			grpAnket.DrawString("www.verivizyon.com", fntBuyukFont, new SolidBrush(Color.Red), 5, 10);
			grpAnket.DrawString("Hangi futbol takmn tutuyorsunuz?", fntBuyukFont, new SolidBrush(Color.Navy), 5, 30);

			// Anket sonularna gre dikey dikdrtgenler izdiriyoruz...
			for(int i=0,sol=50; i<5; ++i,sol+=50)
			{
				grpAnket.FillRectangle(new SolidBrush(Color.RoyalBlue),sol,(imgAnket_H-SonucYuzde[i]),Bar_W,SonucYuzde[i]);
				grpAnket.DrawString(Sonuc[i].ToString() + " oy", fntKucukFont, new SolidBrush(Color.Red), sol, (imgAnket_H-SonucYuzde[i]-15));
				grpAnket.DrawString(Cevaplar[i], fntBuyukFont, new SolidBrush(Color.Blue), sol, (imgAnket_H-SonucYuzde[i]-35));
			}
			
			// Oluturduumuz grafii Image nesnesinde gsteriyoruz...
			bmpAnket.Save(Server.MapPath("grafik.jpg"), ImageFormat.Jpeg);
			imgAnket.ImageUrl = Server.MapPath("grafik.jpg");

			// Grafii bir dosyaya kaydetmeden ve bir Image nesnesi kullanmadan gstermek istersek aadaki kodu kullanabiliriz...
			// Response.ContentType = "image/jpeg";
			// bmpAnket.Save( Response.OutputStream, ImageFormat.Jpeg);

			// Oluturduumuz nesnelerimizi Garbage Collection'n almasn beklemeden temizliyoruz... 
			grpAnket.Dispose();
			bmpAnket.Dispose();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
